package org.apache.bcel.verifier.structurals;

import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import org.apache.bcel.generic.CodeExceptionGen;
import org.apache.bcel.generic.InstructionHandle;
import org.apache.bcel.generic.MethodGen;

public class ExceptionHandlers {
   private static final ExceptionHandler[] EMPTY_ARRAY = new ExceptionHandler[0];
   private final Map<InstructionHandle, Set<ExceptionHandler>> exceptionHandlers = new HashMap();

   public ExceptionHandlers(MethodGen mg) {
      CodeExceptionGen[] cegs = mg.getExceptionHandlers();
      CodeExceptionGen[] var3 = cegs;
      int var4 = cegs.length;

      for(int var5 = 0; var5 < var4; ++var5) {
         CodeExceptionGen ceg = var3[var5];
         ExceptionHandler eh = new ExceptionHandler(ceg.getCatchType(), ceg.getHandlerPC());

         for(InstructionHandle ih = ceg.getStartPC(); ih != ceg.getEndPC().getNext(); ih = ih.getNext()) {
            ((Set)this.exceptionHandlers.computeIfAbsent(ih, (k) -> {
               return new HashSet();
            })).add(eh);
            ((Set)this.exceptionHandlers.computeIfAbsent(ih, (k) -> {
               return new HashSet();
            })).add(eh);
         }
      }

   }

   public ExceptionHandler[] getExceptionHandlers(InstructionHandle ih) {
      Set<ExceptionHandler> hsSet = (Set)this.exceptionHandlers.get(ih);
      return hsSet == null ? EMPTY_ARRAY : (ExceptionHandler[])hsSet.toArray(ExceptionHandler.EMPTY_ARRAY);
   }
}
